---
title: "Live Perplexity LLM Responses"
url: "https://docs.dataforseo.com/v3/ai_optimization/perplexity/llm_responses/live/"
date: "2026-06-06"
---

## Live Perplexity LLM Responses

  
Live Perplexity LLM Responses endpoint allows you to retrieve structured responses from a specific Perplexity AI model, based on the input parameters.

**Note:** Perplexity uses `web_search` in all `sonar`-family models by default, but it’s not guaranteed to work with every request.

 

 

 ![checked](https://docs.dataforseo.com/v3/wp-content/themes/dataforseo/assets/img/icons/checked-circle.svg) POST  https://api.dataforseo.com/v3/ai\_optimization/perplexity/llm\_responses/live     

      

Pricing

 The cost of the task can be calculated on the [Pricing page](https://dataforseo.com/pricing/ai-optimization/llm-responses).

 

 All POST data should be sent in the [JSON](https://en.wikipedia.org/wiki/JSON) format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live Perplexity LLM Responses call can contain only one task.

**The number of concurrent Live tasks is currently limited to 30 per account for each platform in the LLM Responses.**

**Execution time for tasks set with the Live Perplexity LLM Responses endpoint is currently up to 120 seconds.**

Below you will find a detailed description of the fields you can use for setting a task.

**Description of the fields for setting a task:**

| Field name | Type | Description |
|---|---|---|
| `user_prompt` | string | *prompt for the AI model*   **required field**   the question or task you want to send to the AI model;   you can specify **up to 500 characters** in the `user_prompt` field |
| `model_name` | string | *name of the AI model*   **required field**   `model_name`consists of the actual model name and version name;   if the basic model name is specified, its latest version will be set by default;   you can receive the list of available LLM models by making a separate request to the following endpoint: `https://api.dataforseo.com/v3/ai_optimization/perplexity/llm_responses/models` |
| `max_output_tokens` | integer | *maximum number of tokens in the AI response*   optional field   minimum value: `1`   maximum value: `4096`;   default value: `2048`;   **Note:** if the reasoning model is specified in the request, the output token count may exceed the specified `max_output_tokens` limit |
| `temperature` | float | *randomness of the AI response*   optional field   higher values make output more diverse    lower values make output more focused   minimum value: `0`   maximum value: `1.9`   default value: `0.77` |
| `top_p` | float | *diversity of the AI response*   optional field    controls diversity of the response by limiting token selection   minimum value: `0`   maximum value: `1`    default value: `0.9` |
| `web_search_country_iso_code` | string | *country code for web search localization*   optional field   specify the country ISO code to get localized web search results   **Note:** available only for Perplexity Sonar models   example: `US` |
| `system_message` | string | *instructions for the AI behavior*   optional field   defines the AI's role, tone, or specific behavior    you can specify **up to 500 characters** in the `system_message` field |
| `message_chain` | array | *conversation history*   optional field   array of message objects representing previous conversation turns;   each object must contain:   `role` string with either `user` or `ai` role;   `message` string with message content (max 500 characters);   you can specify **maximum of 10 message objects** in the array;   **Note:** for Perplexity models, messages must strictly alternate between user and AI roles (`user` → `ai`);   example:   `"message_chain": [{"role":"user","message":"Hello, what’s up?"},{"role":"ai","message":"Hello! I’m doing well, thank you. How can I assist you today?"}]` |
| `tag` | string | *user-defined task identifier*   optional field   *the character limit is 255*   you can use this parameter to identify the task and match it with the result   you will find the specified `tag` value in the `data` object of the response |



  
  
As a response of the API server, you will receive [JSON](https://en.wikipedia.org/wiki/JSON)-encoded data containing a `tasks` array with the information specific to the set tasks.  
  
**Description of the fields in the results array:**  
| Field name | Type | Description |
|---|---|---|
| `version` | string | *the current version of the API* |
| `status_code` | integer | *general status code*   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md)   **Note:** we strongly recommend designing a necessary system for handling related exceptional or error conditions |
| `status_message` | string | *general informational message*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *total tasks cost, USD* |
| `tasks_count` | integer | *the number of tasks in the **`tasks`** array* |
| `tasks_error` | integer | *the number of tasks in the **`tasks`** array returned with an error* |
| **`tasks`** | array | *array of tasks* |
| `id` | string | *task identifier*   **unique task identifier in our system in the [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier) format** |
| `status_code` | integer | *status code of the task*   generated by DataForSEO; can be within the following range: 10000-60000   you can find the full list of the response codes [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `status_message` | string | *informational message of the task*   you can find the full list of general informational messages [here](https://docs.dataforseo.com/v3/appendix/errors.md) |
| `time` | string | *execution time, seconds* |
| `cost` | float | *cost of the task, USD*   includes the base task price plus the `money_spent` value |
| `result_count` | integer | *number of elements in the `result` array* |
| `path` | array | *URL path* |
| `data` | object | *contains the same parameters that you specified in the POST request* |
| **`result`** | array | *array of results* |
| `model_name` | string | *name of the AI model used* |
| `input_tokens` | integer | *number of tokens in the input*   total count of tokens processed |
| `output_tokens` | integer | *number of tokens in the output*   total count of tokens generated in the AI response |
| `web_search` | boolean | *indicates if web search was used*   **Note:** web search is enabled by default in Perplexity Sonar models |
| `money_spent` | float | *cost of AI tokens, USD*   the price charged by the third-party AI model provider for according to its [Pricing](https://docs.perplexity.ai/guides/pricing) |
| `datetime` | string | *date and time when the result was received*   in the UTC format: “yyyy-mm-dd hh-mm-ss +00:00”   example:   `2019-11-15 12:57:46 +00:00` |
| **`items`** | array | *array of response items*   contains structured AI response data |
| `type` | string | *type of the element = **'message'*** |
| **`sections`** | array | *array of content sections*   contains different parts of the AI response |
| `type` | string | *type of element*=***'text'*** |
| `text` | string | *AI-generated text content* |
| **`annotations`** | array | *array of references used to generate the response*   equals `null` if the `web_search` parameter is not set to `true`   **Note:** `annotations` may return empty even when `web_search` is `true`, as the AI will attempt to retrieve web information but may not find relevant results |
| `title` | string | *the domain name or title of the quoted source* |
| `url` | string | *URL of the quoted source* |
| `fan_out_queries` | array | *array of fan-out queries*   contains related search queries derived from the main query to provide a more comprehensive response |







  
 

 









> Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

```
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/ai_optimization/perplexity/llm_responses/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
  {
    "system_message": "communicate as if we are in a business meeting",
    "message_chain": [
      {
        "role": "user",
        "message": "Hello, what’s up?"
      },
      {
        "role": "ai",
        "message": "Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?"
      }
    ],
    "max_output_tokens": 200,
    "temperature": 0.3,
    "top_p": 0.5,
    "web_search_country_iso_code": "FR",
    "model_name": "sonar",
    "user_prompt": "provide information on how relevant the amusement park business is in France now"
  }
]'
```





```php
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
   // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
   $client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
   exit();
}
$post_array = array();
// You can set only one task at a time
$post_array[] = array(
        "system_message" => "communicate as if we are in a business meeting",
        "message_chain" => [
            [
                "role"    => "user",
                "message" => "Hello, what’s up?"
            ],
            [
                "role"    => "ai",
                "message" => "Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?"
            ]
        ],
        "max_output_tokens" => 200,
        "temperature" => 0.3,
        "top_p" => 0.5,
        "model_name" => "sonar",
        "web_search_country_iso_code" => "FR",
        "user_prompt" => "provide information on how relevant the amusement park business is in France now"
);
if (count($post_array) > 0) {
try {
    // POST /v3/ai_optimization/perplexity/llm_responses/live
    // in addition to 'google' and 'ai_mode' you can also set other search engine and type parameters
    // the full list of possible parameters is available in documentation
    $result = $client->post('/v3/ai_optimization/perplexity/llm_responses/live', $post_array);
    print_r($result);
    // do something with post result
} catch (RestClientException $e) {
    echo "n";
    print "HTTP code: {$e->getHttpCode()}n";
    print "Error code: {$e->getCode()}n";
    print "Message: {$e->getMessage()}n";
    print  $e->getTraceAsString();
    echo "n";
}
$client = null;
?>
```





```js
const axios = require('axios');

axios({
    method: 'post',
    url: 'https://api.dataforseo.com/v3/ai_optimization/perplexity/llm_responses/live',
    auth: {
        username: 'login',
        password: 'password'
    },
    data: [{
    system_message: encodeURI("communicate as if we are in a business meeting"),
    message_chain: [
      {
        role: "user",
        message: "Hello, what’s up?"
      },
      {
        role: "ai",
        message: encodeURI("Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?")
      }
    ],
    max_output_tokens: 200,
    temperature: 0.3,
    top_p: 0.5,
    model_name: "sonar",
    web_search_country_iso_code: "FR",
    user_prompt: encodeURI("provide information on how relevant the amusement park business is in France now")
    }],
    headers: {
        'content-type': 'application/json'
    }
}).then(function (response) {
    var result = response['data']['tasks'];
    // Result data
    console.log(result);
}).catch(function (error) {
    console.log(error);
});
```





```
"""
Method: POST
Endpoint: https://api.dataforseo.com/v3/ai_optimization/perplexity/llm_responses/live
@see https://docs.dataforseo.com/v3/ai_optimization/perplexity/llm_responses/live
"""

import sys
import os
sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), '../../../../../')))
from lib.client import RestClient
from lib.config import username, password
client = RestClient(username, password)

post_data = []
post_data.append({
        'system_message': 'communicate as if we are in a business meeting',
        'message_chain': [
            {
                'role': 'user',
                'message': 'Hello, what's up?'
            },
            {
                'role': 'ai',
                'message': 'Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?'
            }
        ],
        'max_output_tokens': 200,
        'temperature': 0.3,
        'top_p': 0.5,
        'web_search_country_iso_code': 'FR',
        'model_name': 'sonar',
        'user_prompt': 'provide information on how relevant the amusement park business is in France now'
    })
try:
    response = client.post('/v3/ai_optimization/perplexity/llm_responses/live', post_data)
    print(response)
    # do something with post result
except Exception as e:
    print(f'An error occurred: {e}')
```





```csharp
using System;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Collections.Generic;
using System.Threading.Tasks;
using Newtonsoft.Json;
namespace DataForSeoSdk;

public class AiOptimization
{

    private static readonly HttpClient _httpClient;
    
    static AiOptimization()
    {
        _httpClient = new HttpClient
        {
            BaseAddress = new Uri("https://api.dataforseo.com/")
        };
        _httpClient.DefaultRequestHeaders.Authorization =
            new AuthenticationHeaderValue("Basic", ApiConfig.Base64Auth);
    }
    /// <summary>
    /// Method: POST
    /// Endpoint: https://api.dataforseo.com/v3/ai_optimization/perplexity/llm_responses/live
    /// </summary>
    /// <see href="https://docs.dataforseo.com/v3/ai_optimization/perplexity/llm_responses/live"/>
    
    public static async Task PerplexityLlmResponsesLive()
    {
        var postData = new List<object>();
        // a simple way to set a task, the full list of possible parameters is available in documentation
        postData.Add(new
        {
            system_message = "communicate as if we are in a business meeting",
            message_chain = new object[]
            {
                new
                {
                    role = "user",
                    message = "Hello, what's up?"
                },
                new
                {
                    role = "ai",
                    message = "Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?"
                }
            },
            max_output_tokens = 200,
            temperature = 0.3,
            top_p = 0.5,
            web_search_country_iso_code = "FR",
            model_name = "sonar",
            user_prompt = "provide information on how relevant the amusement park business is in France now"
        });

        var content = new StringContent(JsonConvert.SerializeObject(postData), Encoding.UTF8, "application/json");
        using var response = await _httpClient.PostAsync("/v3/ai_optimization/perplexity/llm_responses/live", content);
        var result = JsonConvert.DeserializeObject<dynamic>(await response.Content.ReadAsStringAsync());
        // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
        if (result.status_code == 20000)
        {
            // do something with result
            Console.WriteLine(result);
        }
        else
            Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
    }
```





> The above command returns JSON structured like this:

```
{
  "version": "0.1.20251208",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "4.1058 sec.",
  "cost": 0.008312,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "12111524-1535-0612-0000-94140c948793",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "4.0250 sec.",
      "cost": 0.008312,
      "result_count": 1,
      "path": [
        "v3",
        "ai_optimization",
        "perplexity",
        "llm_responses",
        "live"
      ],
      "data": {
        "api": "ai_optimization",
        "function": "llm_responses",
        "se": "perplexity",
        "system_message": "communicate as if we are in a business meeting",
        "message_chain": [
          {
            "role": "user",
            "message": "Hello, what's up?"
          },
          {
            "role": "ai",
            "message": "Hello! I’m doing well, thank you. How can I assist you today? Are there any specific topics or projects you’d like to discuss in our meeting?"
          }
        ],
        "max_output_tokens": 200,
        "temperature": 0.3,
        "top_p": 0.5,
        "web_search_country_iso_code": "FR",
        "model_name": "sonar",
        "user_prompt": "provide information on how relevant the amusement park business is in France now"
      },
      "result": [
        {
          "model_name": "sonar",
          "input_tokens": 64,
          "output_tokens": 198,
          "web_search": true,
          "money_spent": 0.007712,
          "datetime": "2025-12-11 15:25:00 +00:00",
          "items": [
            {
              "type": "message",
              "sections": [
                {
                  "type": "text",
                  "text": "<think>nI need to provide information on how relevant the amusement park business is in France now, based on the search results provided. Let me analyze the key information from these sources.nnFrom the search results, I can gather the following key points about the amusement park business in France:nn1. Market Size and Growth:n   - According to source [1], the France Amusement Parks Market was valued at 2.35 USD Billion in 2024 and is projected to reach 3.41 USD Billion by 2032, growing at a CAGR of 6.10% from 2025 to 2032.n   - Source [2] states the France amusement parks market generated a revenue of USD 3,249.3 million (approximately 3.25 billion USD) in 2024 and is expected to reach USD 4,274.3 million by 20",
                  "annotations": [
                    {
                      "title": "France Amusement Parks Market to 2032",
                      "url": "https://www.databridgemarketresearch.com/nucleus/france-amusement-parks-market"
                    },
                    {
                      "title": "France Amusement Parks Market Size & Outlook, 2025-2030",
                      "url": "https://www.grandviewresearch.com/horizon/outlook/amusement-parks-market/france"
                    },
                    {
                      "title": "France Amusement park Market (2025-2031) Outlook",
                      "url": "https://www.6wresearch.com/industry-report/france-amusement-park-market-outlook"
                    },
                    {
                      "title": "Astérix Park: 250 Million Euros to Reach the European Top 5",
                      "url": "https://www.parktrips.fr/en/parc-asterix-paris/post-2726.html"
                    },
                    {
                      "title": "Amusement Parks - France | Statista Market Forecast",
                      "url": "https://www.statista.com/outlook/amo/entertainment/amusement-parks/france"
                    },
                    {
                      "title": "France Theme Park Tourism Market Size, Share & Growth ...",
                      "url": "https://deepmarketinsights.com/vista/insights/theme-park-tourism-market/france"
                    },
                    {
                      "title": "PARC ASTERIX IS INVESTING €250M TO CONFIRM ITS ...",
                      "url": "https://newsroom.parcasterix.fr/actualites/strongparc-asterix-investit-250-m-eur-pour-consolider-sa-place-de-2supemesup-parc-francais-et-rentrer-dans-le-top-5-des-parcs-incontournables-en-europe-strong-25010/?lang=en"
                    },
                    {
                      "title": "Europe Amusement Parks Market Size & Share Analysis",
                      "url": "https://www.mordorintelligence.com/industry-reports/europe-amusement-parks-market"
                    }
                  ]
                }
              ]
            }
          ],
          "fan_out_queries": null
        }
      ]
    }
  ]
}
```









 

  cURL   php   Node.js   Python   cSharp